package crystalpalace.pe;

import crystalpalace.export.*;
import crystalpalace.util.*;
import java.util.*;

import crystalpalace.coff.*;

public class PEParser {
	protected byte[]   data;
	protected PEObject object;

	public PEParser(byte[] data) {
		this.data = data;
	}

	public PEObject parse() {
		ByteWalker parser = new ByteWalker(data);
		return new PEObject(parser);
	}

	public static void main(String args[]) {
		if (args.length == 0) {
			System.out.println("./peparser [/path/to/file.dll]");
			return;
		}

		try {
			String desc = new PEParser(CrystalUtils.readFromFile(args[0])).parse().toString();
			CrystalUtils.print_info(desc);
		}
		catch (Exception ex) {
			CrystalUtils.handleException(ex);
		}
	}
}
